<?php

define("_if",0x0001,true);
define("_then",0x0002,true);
define("_block",0x0003,true);
define("_catch_block_list_not_empty",0x0004,true);
define("_exception_type",0x0005,true);
define("_final_block_not_empty",0x0006,true);
define("_structure",0x0006,true);
define("_true",0x0007,true);
define("_false",0x0008,true);

define("_if_block",0x0009,true);
define("_condition",0x000a,true);
define("_condition_with_parenthesis",0x000b,true);
define("_then_block",0x000c,true);
define("_else_block",0x000d,true);
define("_else",0x000e,true);
define("_else_not_empty",0x000f,true);
define("_switch_block",0x0010,true);
define("_switch",0x0011,true);
define("_case_condition",0x0012,true);
define("_case",0x0013,true);

define("_valiable_with_parenthesis",0x0014,true);
define("_blanches_block",0x0015,true);
define("_blanches_block_inner_not_empty",0x0016,true);
define("_blanches_block_inner",0x0017,true);
define("_blanches_block_inner_single",0x0018,true);
define("_commandlist",0x0019,true);
define("_commandlist_not_empty",0x001a,true);
define("_command",0x001b,true);
define("_try_catch_finally",0x001c,true);
define("_try_block",0x001d,true);
define("_try",0x001e,true);

define("_catch_block_list",0x001f,true);
define("_catch_block",0x0020,true);
define("_catch",0x0021,true);

define("_finally_block",0x0022,true);
define("_finally",0x0023,true);
define("_extends_relation",0x0024,true);
define("_extends",0x0025,true);


define("_define",0x0026,true);

define("_array",0x0027,true);
define("_setvalue",0x0028,true);
define("_getvalue",0x0029,true);
define("_node",0x002a,true);
define("_valiable",0x0030,true);
define("_element",0x0031,true);
define("_null",0x0032,true);
define("_undef",0x0033,true);

define("_bnf_type",0x0034,true);
define("_bnf_type_combine",0x0035,true);
define("_bnf_type_or",0x0036,true);
define("_bnf_type_token",0x0037,true);

define("_parenthesis",0x0038,true);
define("_closing_parenthesis",0x0039,true);
define("_bracket",0x003a,true);
define("_closing_bracket",0x003b,true);

define("_name",0x003c,true);
define("_child",0x003d,true);

define("_token_if","if",true);
define("_token_else","else",true);
define("_token_switch","switch",true);
define("_token_case","case",true);

define("_token_parenthesis","(",true);
define("_token_closing_parenthesis",")",true);
define("_token_bracket","{",true);
define("_token_closing_bracket","}",true);
define("_token_try","try",true);
define("_token_catch","catch",true);
define("_token_finally","finally",true);
define("_token_extends","extends",true);

$BNFDef=array(
// Token Definition
_if=>array(
_name=>"if",
_bnf_type=>_bnf_type_token,
_child=>array(_token_if)
),
_parenthesis=>array(
_name=>"(",
_bnf_type=>_bnf_type_token,
_child=>array(_token_parenthesis)
),
_closing_parenthesis=>array(
_name=>")",
_bnf_type=>_bnf_type_token,
_child=>array(_token_closing_parenthesis)
),
_bracket=>array(
_name=>"{",
_bnf_type=>_bnf_type_token,
_child=>array(_token_bracket)
),
_closing_bracket=>array(
_name=>"}",
_bnf_type=>_bnf_type_token,
_child=>array(_token_closing_bracket)
),
_else=>array(
_name=>"else",
_bnf_type=>_bnf_type_token,
_child=>array(_token_else)
),
_switch=>array(
_name=>"switch",
_bnf_type=>_bnf_type_token,
_child=>array(_token_switch)
),
_case=>array(
_name=>"case",
_bnf_type=>_bnf_type_token,
_child=>array(_token_case)

),
_try=>array(
	_name=>"try",
	_bnf_type=>_bnf_type_token,
	_child=>array(_token_try)
),
_catch=>array(
	_name=>"catch",
	_bnf_type=>_bnf_type_token,
	_child=>array(_token_catch)
),
_finally=>array(
	_name=>"finally",
	_bnf_type=>_bnf_type_token,
	_child=>array(_token_finally)
),



// BNF
_if_block=>array(
_name=>"if_block",
_bnf_type=>_bnf_type_combine,
_child=>array(
_if,
_condition_with_parenthesis,
_then,
_else)
),

_condition_with_parenthesis=>array(
_name=>"condition_with_parenthesis",
_bnf_type=>_bnf_type_combine,
_child=>array(
_parenthesis,
_condition,
_closing_parenthesis)
),
_block=>array(
_name=>"block",
_bnf_type=>_bnf_type_combine,
_child=>array(
_bracket,
_commandlist,
_closing_bracket)

),
_then_block=>array(
_name=>"thenBlock",
_bnf_type=>_bnf_type_combine,
_child=>array(_block)
),
_else_block=>array(
_name=>"else",
_bnf_type=>_bnf_type_or,
_child=>array(
_else_not_empty,
_null)
),
_else_not_empty=>array(
_name=>"else_not_empty",
_bnf_type=>_bnf_type_combine,
_child=>array(
_else,
_block,
)
),
_switch_block=>array(
_name=>"switch",
_bnf_type=>_bnf_type_combine,
_child=>array(
_switch,
_valiable_with_parenthesis,
_blanches_block)
),
_valiable_with_parenthesis=>array(
_name=>"valiable_with_parenthesis",
_bnf_type=>_bnf_type_combine,
_child=>array(
_parenthesis,
_valiable,
_closing_parenthesis)
),
_blanches_block=>array(
_name=>"blanches_block",
_bnf_type=>_bnf_type_combine,
_child=>array(
_bracket,
_blanches_block_inner_not_empty,
_closing_bracket)
),
_blanches_block_inner_not_empty=>array(
_name=>"blanches_block_inner_not_empty",
_bnf_type=>_bnf_type_combine,
_child=>array(
_blanches_block_inner_single,
_blanches_block_inner)
),
_blanches_block_inner=>array(
_name=>"blanches_block_inner",
_bnf_type=>_bnf_type_combine,
_child=>array(
_blanches_block_inner_single,
_blanches_block_inner)
),
_blanches_block_inner_single=>array(
_name=>"blanches_block_inner_single",
_bnf_type=>_bnf_type_combine,
_child=>array(
_case,
_commandlist)
),
_case_condition=>array(
_name=>"case",
_bnf_type=>_bnf_type_combine,
_child=>array(
_case,
_valiable,
":")
),
_commandlist=>array(
_name=>"commandlist",
_bnf_type=>_bnf_type_or,
_child=>array(
_null,
_commandlist_not_empty
)
),
_commandlist_not_empty=>array(
_name=>"commandlist_not_empty",
_bnf_type=>_bnf_type_combine,
_child=>array(
_command,
_commandlist)
),
_try_catch_finally=>array(
_name=>"try_catch_finally",
_bnf_type=>_bnf_type_combine,
_child=>array(
_try_block,
_catch_block_list,
_finally_block)
),
_try_block=>array(
_name=>"try_block",
_bnf_type=>_bnf_type_combine,
_child=>array(
_try,
_block
)
),
_catch_block_list=>array(
_name=>"catch_block_list",
_bnf_type=>_bnf_type_or,
_child=>array(
_catch_block_list_not_empty,
_null
)
),
_catch_block_list_not_empty=>array(
_name=>"catch_block_list_not_empty",
_bnf_type=>_bnf_type_combine,
_child=>array(
_catch_block,
_catch_block_list
)
),
_catch_block=>array(
_name=>"catch_block",
_bnf_type=>_bnf_type_combine,
_child=>array(
_catch,
_parenthesis,
_exception_type,
_valiable,
_closing_parenthesis,
_block
)
),
_finally_block=>array(
_name=>"finally_block",
_bnf_type=>_bnf_type_or,
_child=>array(
_null,
_final_block_not_empty
)
),
_final_block_not_empty=>array(
_name=>"finally_block_not_empty",
_bnf_type=>_bnf_type_combine,
_child=>array(
    _finally,
    _block
)
),

_extends_relation=>array(
_name=>"extends",
_bnf_type=>_bnf_type_combine,
_child=>array(_node, _extends,_node)
),
_define=>array(
_name=>"define",
),

_define=>array("name"=>"define","child"=>array("name"=>_valiable,"value"=>_node)),
_element=>array("name"=>"element","child"=>array(_valiable,_command)),
_node=>array("name"=>"node","child"=>array(_element,_structure))

);
?>